static char* g_tipmsg_id = "@(#) $Id: tipmsg.c,v 1.3 2000/06/23 04:57:55 kouno Exp $";

/* 
 *  Project: IPMSG
 *  Author & Copyright:  KOHNO TAKASHI(δ) <kouno@catnet.ne.jp>
 *  Mail: kouno@catnet.ne.jp
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <limits.h>		   
#include <netdb.h>
#include <signal.h>
#include <pwd.h>
#include <errno.h>
#include <time.h>
#include <fcntl.h>
#include <ctype.h>
#include <sys/wait.h>
#include <sys/mman.h>
#include <sys/time.h>
#include <sys/stat.h>
#include <sys/param.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include "protocol.h"
#include "tipmsg.h"

#if defined(DEBUG)
#define line	fprintf(stderr, "Line %d\n", __LINE__);fflush(stderr);fflush(stdout)
#define d_printf printf
#else
#define debug
#define d_printf dummy_function
#endif

/* ѿ  */
static int g_exit = 0;
/* ѿ ޤ */

int main(int argc, char *argv[])
{
	NET_MNG net_mng;
	CONFIG_MNG config_mng;
	USERLIST_MNG userlist_mng = {NULL, NULL};
	MSGPACKAGE_MNG msgpackage_mng = {NULL, NULL, NULL, 0};

	NET_MNG* net = &net_mng;
	CONFIG_MNG* cfg = &config_mng;
	USERLIST_MNG* ulm = &userlist_mng;
	MSGPACKAGE_MNG* mpm =  &msgpackage_mng;

    int ret = 0, flag=1, pos;
	struct sockaddr_in	saddr;
	memset(net, 0, sizeof(NET_MNG));
	memset(cfg, 0, sizeof(CONFIG_MNG));

	/* Ԥʤ */
	if (!(pos = configuratin(argc, argv, cfg))){
		return 1;
	}
	net->append = cfg->append;
	mpm->max_store_message = cfg->store_message;

	/* Tearminate */
	if (cfg->special_mode & SPECIAL_TERM_MODE){
		kill(read_pid_file(cfg->pid_file), SIGTERM);
		printf("Tearminate...\n");
		ret = 0;
		goto END;
	}

	/* ǡ⡼ɤ */
	if (cfg->daemon && !cfg->special_mode){
		became_a_daemon(argv);
	}

	/* ǥ쥯ȥ */
	mkdir(cfg->tipmsgdir, 0700);
	mkdir(cfg->paper_log_dir, 0700);
	

	/* Ժ߾֤򥳥ޥɤȿ */
	if (cfg->absence.mode){
		net->append.ret |= IPMSG_ABSENCEOPT;
	} else {
		net->append.ret &= ~IPMSG_ABSENCEOPT;
	}

	/* 桼̾ */
	if (!cfg->nickname[0]){
        strcpy(cfg->nickname, getpwuid(getuid())->pw_name);
    }
	
	/* UDP åȤν */
	if ((net->sd = socket(AF_INET, SOCK_DGRAM, 0)) == -1){
		perror("Can't create UDP socket\n");
		return 1;
	}
	d_printf("SD is %d\n", net->sd);
    flag = 1;
    if (setsockopt(net->sd, SOL_SOCKET, SO_BROADCAST, (char*)&flag, sizeof(int)) == -1) {
        perror("setsockopt fail(SO_BROADCAST)");
    }

	/* sockaddr_in¤Τ */
	memset((char *)&saddr, 0, sizeof(saddr));
	saddr.sin_family		= AF_INET;
	saddr.sin_addr.s_addr	= htonl(INADDR_ANY);
	if (cfg->special_mode & SPECIAL_SEND_MODE){
		saddr.sin_port			= htons(INADDR_ANY);
	} else {
		saddr.sin_port			= htons(cfg->ipmsg_port);
	}
	/* UDP åȥХ */
	if (bind(net->sd, (struct sockaddr *)&saddr, sizeof(saddr)) == -1){
		fprintf(stderr, "UDP Bind error %d port : %s\n", 
				cfg->ipmsg_port, ERRMSG);
		goto END;
	}

	/* send mode */
	if (cfg->special_mode & SPECIAL_SEND_MODE){
		if (access(cfg->pid_file, F_OK) != 0){
			fprintf(stderr, "Server not found, because no pid file(%s)\n",
				   cfg->pid_file);
			return 1;
		}
		send_message(net, cfg, ulm, argv + pos);
		goto END;
	}

    /* SIGNAL */
	set_signal(interrupt_exit);

	/* Ԥ */
	create_pid_file(cfg->pid_file);
	if (!recver(net, cfg, ulm, mpm)){
		ret = 1;
	}
	unlink(cfg->pid_file);

 	/* λ */
	information_for_everybody(NULL, 0, IPMSG_BR_EXIT, net, cfg, ulm);
  END:
	destroy_userlist(ulm);
 	close(net->sd);
	return ret;
}

/* Ԥʤ */
int configuratin(int argc, char** argv, CONFIG_MNG* cfg)
{
	int pos;

	/* ǥե */
	default_config(cfg);

	/* ե뤬ꤵƤ̾ */
	if (!(pos = analyze_option(argc, argv, cfg))) return FALSE;
	/* ե */
	if (!cfg->filename[0]){
		sprintf(cfg->filename, "%s/%s", cfg->tipmsgdir, CONFIG_FILE);
	}
	d_printf("Config file is %s\n", cfg->filename);
	/* ե뤫ɤ߹ */
    if (!load_config(cfg->filename, cfg)){
    /*	return 1; */
	}
	/* ưץβ */
	if (!analyze_option(argc, argv, cfg)){
		return FALSE;
	}
	/* ν */
	if (!proceed_config(cfg)){
		return FALSE;
	}
	return pos;
}

/* ޥɥ饤β */
int analyze_option(int argc, char** argv, CONFIG_MNG* cfg)
{
    char* endp;
	int opt, i, lp;
	char* options = "PCef"; /* Need argument */
#if(0)
	char* options_all = "ABCDEHJKLNPQSUXefhkmrstux";
#endif
	static int reanalyze = FALSE;
	char* Xoptarg;

    /* β */
	for (lp=1; lp<argc; lp++){
		if (argv[lp][0] != '-') {
			d_printf("Unknown option(%s).\n", argv[lp]);
			break;
		}
		opt = argv[lp][1];
		d_printf("Designate option(%c).\n", (char)opt);
		if (argv[lp][2] == '\0'){
			if (!argv[lp+1] || *(Xoptarg = argv[lp+1]) == '-') Xoptarg = "";
			else if (strchr(options, opt)) lp++;
		} else {
			Xoptarg = argv[lp] +3;
		}
		d_printf("Designate optarg(%d:%s).\n", lp, Xoptarg);
		if (!reanalyze){
			if (opt == 'C'){
				if (reanalyze) break;
				if (access(Xoptarg, R_OK) == 0){
					strcpy(cfg->filename, Xoptarg);
				} else {
					fprintf(stderr, "Invalid config file(%s) : %s\n",
							Xoptarg, ERRMSG);
					return 0;
				}
				d_printf("Designate config(%s).\n", cfg->filename);
				break;
			}
			continue;
		}
		switch (opt){
		case 'A':
			if (!cfg->absence.mode){
				d_printf("I'm absence.\n");
				cfg->absence.mode = TRUE;
			} else {
				d_printf("I'm exist.\n");
				cfg->absence.mode = FALSE;
			}
			break;
		case 'Q':
			if (!cfg->print_entry){
				d_printf("Printable Entry & Exit.\n");
				cfg->print_entry = TRUE;
			} else {
				d_printf("No Printable Entry & Exit.\n");
				cfg->print_entry = FALSE;
			}
			break;
		case 'P':
			if ((i = strtol(Xoptarg, &endp, 0)) != 0){
				cfg->ipmsg_port = i;
			}
			d_printf("Designate port[%d].\n", i);
			break;
		case 'L':
			if (!cfg->live){
				d_printf("Live mode\n");
				cfg->live = TRUE;
			} else {
				d_printf("Silent mode\n");
				cfg->live = FALSE;
			}
			break;
		case 'D':
			if (!cfg->daemon){
				d_printf("Call daemon.\n");
				cfg->daemon = TRUE;
			} else {
				d_printf("Daemon free.\n");
				cfg->daemon = FALSE;
			}
			break;
		case 'U':
			if (!cfg->flush_userlist){
				d_printf("Create userlist.\n");
				cfg->flush_userlist = TRUE;
			} else {
				d_printf("No use userlist.\n");
				cfg->flush_userlist = FALSE;
			}
			break;
		case 'N':
			if (!cfg->no_entry){
				d_printf("Hide ....\n");
				cfg->no_entry = TRUE;
				cfg->append.send |= IPMSG_NOADDLISTOPT;
			} else {
				d_printf("Look me!\n");
				cfg->no_entry = FALSE;
				cfg->append.send &= ~IPMSG_NOADDLISTOPT;
			}
			break;
		case 'S':
			Xstrncpy(cfg->char_code, CODE_SJIS, NAMELEN);
			d_printf("Kanji code is %s\n", cfg->char_code);
			break;
		case 'E':
			Xstrncpy(cfg->char_code, CODE_EUCJP, NAMELEN);
			d_printf("Kanji code is %s\n", cfg->char_code);
			break;
		case 'J':
			Xstrncpy(cfg->char_code, CODE_JIS, NAMELEN);
			d_printf("Kanji code is %s\n", cfg->char_code);
			break;
		case 'B':
			Xstrncpy(cfg->char_code, "", NAMELEN);
			d_printf("Bare Kanji code is no transfer.\n");
			break;
		case 'K':
		case 'k':
			if (cfg->append.send & IPMSG_PASSWORDOPT) {
				d_printf("Disable password opt.\n");
				cfg->append.send &= ~IPMSG_PASSWORDOPT;
			} else {
				d_printf("Enable password opt.\n");
				cfg->append.send |= IPMSG_PASSWORDOPT;
				cfg->append.send &= ~IPMSG_SECRETOPT;
			}
		case 'X':
		case 'x':
			if (cfg->append.send & IPMSG_SECRETOPT){
				d_printf("Disable secret opt.\n");
				cfg->append.send &= ~IPMSG_SECRETOPT;
			} else {
				d_printf("Enable secret opt.\n");
				cfg->append.send |= IPMSG_SECRETOPT;
			}
			break;
		case 'H':
		case 'h':
			/* إ */
			print_usage();
			exit(0);
		case 'e':
			Xstrncpy(cfg->editor, Xoptarg, PATH_MAX);
			d_printf("Designate editor is %s.\n", cfg->editor);
			break;
		case 's':
			d_printf("Send mode\n");
			cfg->special_mode |= SPECIAL_SEND_MODE;
			break;
		case 'u':
			d_printf("Use username\n");
			cfg->special_mode |= SPECIAL_SEND_MODE|SPECIAL_OPT_USE_USERNAME;
			break;
		case 't':
			d_printf("Operate terminate\n");
			cfg->special_mode |= SPECIAL_TERM_MODE;
			break;
		case 'r':
			d_printf("Reply mode\n");
			cfg->special_mode |= SPECIAL_SEND_MODE|SPECIAL_OPT_REPLY;
			cfg->reply = strtol(Xoptarg, &endp, 0);
			break;
		case 'f':
			cfg->special_mode |= SPECIAL_SEND_MODE;
			cfg->send_file_keep_it = TRUE;
			Xstrncpy(cfg->send_file, Xoptarg, PATH_MAX);
			d_printf("Designate sendfile : %s\n", cfg->send_file);
			break;
		default:
			break;
		}
	}

	reanalyze = TRUE;
	d_printf("Analyze Done(%d)\n", lp);
	return lp;
}

/*
 * ǥեȤνܤ
 */
int default_config(CONFIG_MNG* cfg)
{
	cfg->live = TRUE;
	cfg->daemon = FALSE;
	cfg->flush_userlist = FALSE;
	cfg->no_entry = FALSE;
	cfg->print_entry = FALSE;
	cfg->ipmsg_port = IPMSG_PORT;
	cfg->store_message = DEFAULT_STORE_MESSAGE;
	cfg->hw_kana = 1;
	cfg->flush_userlist = 1;

	cfg->absence.mode = FALSE;

	/* ƥǥ쥯ȥ */
#if defined(TIPMSGDIR)
	strcpy(cfg->tipmsgdir, TIPMSGDIR_PATH);
#else
	sprintf(cfg->tipmsgdir, "%s/%s", getenv(ENV_HOME), TIPMSGDIR_PATH);
#endif
	/* ֥ɥ㥹 */
	cfg->broadcast.num =1;	
	cfg->broadcast.addr[0] = strdup(BROADCAST);

	return TRUE;
}

/* ̤ܤκ */
int proceed_config(CONFIG_MNG* cfg)
{
	struct passwd* pw;
	char *ostype, *hosttype, *p;
	char buf[0x400];

	/* ̤Υȥ(Ϣ³) */
	if (cfg->paper_log_dir[0] && cfg->paper_log_dir[0] != '/'){
		Xstrncpy(buf, cfg->paper_log_dir, 0x400);
		sprintf(cfg->paper_log_dir, "%s/%s",  cfg->tipmsgdir, buf);
	} else if (!cfg->paper_log_dir[0])
		sprintf(cfg->paper_log_dir, "%s/%s",  cfg->tipmsgdir, DEFAULT_PAPER_DIR);

	if (cfg->scroll_log_file[0] && cfg->scroll_log_file[0] != '/'){
		Xstrncpy(buf, cfg->scroll_log_file, 0x400);
		sprintf(cfg->scroll_log_file, "%s/%s",  cfg->tipmsgdir, buf);
	} else if (!cfg->scroll_log_file[0])
		sprintf(cfg->scroll_log_file, "%s/%s", cfg->tipmsgdir, DEFAULT_SCROLL_FILE);
	/* 桼ꥹ */
	if (cfg->userlist_file[0] && cfg->userlist_file[0] != '/'){
		Xstrncpy(buf, cfg->userlist_file, 0x400);
		sprintf(cfg->userlist_file, "%s/%s",  cfg->tipmsgdir, buf);
	} else if (!cfg->userlist_file[0])
		sprintf(cfg->userlist_file, "%s/%s", cfg->tipmsgdir, DEFAULT_USERLIST);

	/* ˥å͡ȥ롼̾ */
	if (!cfg->nickname[0])
		strcpy(cfg->nickname, getpwuid(getuid())->pw_name);

	/* С */
	hosttype=getenv(ENV_HOSTTYPE);
	ostype=getenv(ENV_OSTYPE);

	if (!cfg->vermsg[0])
		sprintf(cfg->vermsg, "Text IP Messenger %s for %s %s\n\n\nBuild %s", 
				TIPMSG_VERSION,  hosttype ? hosttype : "Unknown Host", 
				ostype ? ostype : "Unknown OS", g_tipmsg_id);

	/* Ժ߾ */
	if (cfg->absence.file[0] && cfg->absence.file[0] != '/'){
		Xstrncpy(buf, cfg->absence.file, 0x400);
		sprintf(cfg->absence.file, "%s/%s",  cfg->tipmsgdir, buf);
	} else if (!cfg->absence.file[0])
		sprintf(cfg->absence.file, "%s/%s", cfg->tipmsgdir, DEFAULT_ABSENCEFILE);

	/* ۥ̾ȥ桼̾ */
	if (!cfg->hostname[0]){
		if (gethostname(cfg->hostname, MAXBUFLEN) != -1){
			if ((p = strchr(cfg->hostname, '.')) != NULL) *p = '\0';
		} else {
			strcpy(cfg->hostname,"Unknown host");
		}
	}
	if (!cfg->username[0]){
		if ((pw = getpwuid(getuid()))){
			strcpy(cfg->username, pw->pw_name);
		} else {
			strcpy(cfg->username, "Unknown user");
		}
	}

	/* PID ե̾ */
	if (cfg->pid_file[0] && cfg->pid_file[0] != '/'){
		Xstrncpy(buf, cfg->pid_file, 0x400);
		sprintf(cfg->pid_file, "%s/%s",  cfg->tipmsgdir, buf);
	} else if (!cfg->pid_file[0]){
		sprintf(cfg->pid_file, "%s/%s", cfg->tipmsgdir, DEFAULT_PIDFILE);
    }
	/* server */
	if (!cfg->server[0]){
		Xstrncpy(cfg->server, "127.0.0.1", NAMELEN);
	}
	/* code */
	if (!cfg->char_code[0]){
		Xstrncpy(cfg->server, CODE_SJIS, NAMELEN);
	}
	/* send file */
	if (!cfg->send_file[0]){
		sprintf(cfg->send_file, "%s/%s",  cfg->tipmsgdir, DEFAULT_SENDFILE);
	}

	return TRUE;
}

/* ե뤫ͤ */
char** make_value(char** key)
{
	int lp;
	char* p;
	char** value = NULL;
	for (lp=0; key[lp]; lp++);
	if (!(value = (char**)calloc(sizeof(char*), lp+1))) goto ERR;

	for (lp=0; key[lp]; lp++){
		/* Ȥκ */
		if ((p = strchr(key[lp], '#'))) *p = '\0';
		if ((p = strchr(key[lp], '['))) *p = '\0';
		if (*key[lp] == '\0') continue;

		/* `='򶭤 key(), value()ʬ */
		if (!(value[lp] = strchr(key[lp],'='))){
			continue;
		}
		*value[lp] = '\0';

		/* ɬפʶκ(key) */
		for (p = key[lp] ; isspace(*p); p++);
		key[lp] = p;
		for (p = value[lp]-1; isspace(*p) && p > key[lp]; p--) *p = '\0';
		/* ɬפʶκ(value) */
		for (p = value[lp]+1; isspace(*p); p++);
		if (*p)	{
			value[lp] = p;
		} else {
			value[lp] = NULL;
			continue;
		}
		for (p = value[lp] ; *p; p++);
		for (p--; isspace(*p) && p > value[lp]; p--) *p = '\0';
	}
	return value;
  ERR:
	free(value);
	perror("Fail in make_value");
	return 0;
}

/* եʬ䤷ƥ˳Ǽ */
char** make_key(char* file)
{
	int lines, fd, pos, size, unit = 1024;
	char* buf = NULL;
	char** key = NULL;
	struct stat sbuf;
	/* եɤ߹ */
	if ((fd = open(file, O_RDONLY)) == -1) goto ERR;
	if (fstat(fd, &sbuf) == -1 || sbuf.st_size == 0) goto ERR;
	free(buf);
	if (!(buf = (char*)malloc(sbuf.st_size +1))) goto ERR;
	if (read(fd, buf, sbuf.st_size) < sbuf.st_size) goto ERR;
	close(fd);
	fd = -1;
	buf[sbuf.st_size] = '\0';

	/* ʬ */
	size = unit;
	lines = 0;
	free(key);
	if (!(key = (char**)malloc(sizeof(char*) * unit))) goto ERR;
	key[lines++] = buf;

	for (pos = 0; pos < sbuf.st_size; pos++){
 		if (lines +1 >= size){
			char **tmp;
			size += unit;
			if (!(tmp = (char**)realloc(key, sizeof(char*) * size))){
				goto ERR;
			}
			key = tmp;
		}
		if (buf[pos] == '\\'){
			pos++;
			continue;
		}
		if (buf[pos] == '\n'){
			buf[pos] = '\0';
			key[lines++] = buf + pos + 1;
		}
	}
	key[lines] = NULL;
	return key;

  ERR:
	perror("Fail in make_key");
	free(key);
	free(buf);buf = NULL;
	if (fd != -1) close(fd);
	return 0;
}

int load_config(char* fname, CONFIG_MNG* cfg)
{
	char** key;
	char** value;
	int lp, i;
	char* endp;

	if (!(key = make_key(fname))){
		return FALSE;
	}
	if (!(value = make_value(key))){
		free(key);
		return FALSE;
	}
	for (lp=0; key[lp]; lp++){
		if (!value[lp]) continue;
		/* 
		   NETWORK 
		*/
		if (strcasecmp(key[lp], "broadcast") == 0){
			char* buf;
			char* p;
			int num = cfg->broadcast.num;
			if (!(buf = strdup(value[lp]))) continue;
			for (p = strtok(buf, " ,"); p; p = strtok(NULL, " ,")){
				if (!(cfg->broadcast.addr[num++] = strdup(p))) break;
				if (num >= BROADCAST_MAX){
					d_printf("Too many broadcast address.\n");
					break;
				}
			}
			cfg->broadcast.num = num;
			free(buf);
		} else if (strcasecmp(key[lp], "server") == 0) {
			Xstrncpy(cfg->server, value[lp], NAMELEN);
		} else if (strcasecmp(key[lp], "port") == 0) {
			if ((i = strtol(value[lp], &endp, 0)) != 0) cfg->ipmsg_port = i;
		} 
		/* 
		   USER INFORMATION 
		*/
		else if (strcasecmp(key[lp], "name") == 0) {
			Xstrncpy(cfg->nickname, value[lp], NAMELEN);
		} else if (strcasecmp(key[lp], "hostname") == 0) {
			Xstrncpy(cfg->hostname, value[lp], NAMELEN);
		} else if (strcasecmp(key[lp], "group") == 0) {
			Xstrncpy(cfg->groupname, value[lp], NAMELEN);
		}	
		/* 
		   FILE 
		*/
		else if (strcasecmp(key[lp], "system dir") == 0) {
			if (*value[lp] == '~' && *(value[lp]+1) == '/'){
				sprintf(cfg->tipmsgdir, "%s%s", getenv(ENV_HOME), value[lp]+1);
			} else {
				Xstrncpy(cfg->tipmsgdir, value[lp], PATH_MAX);
			}
		} else if (strcasecmp(key[lp], "absence file") == 0) {
			Xstrncpy(cfg->absence.file, value[lp], PATH_MAX);
		}
		else if (strcasecmp(key[lp], "read check") == 0){
			if (strcasecmp(value[lp], "yes") == 0){
				cfg->append.send |= IPMSG_READCHECKOPT;
			} else {
				cfg->append.send &= ~IPMSG_READCHECKOPT;
			}
		} else if (strcasecmp(key[lp], "secret") == 0){
			if (strcasecmp(value[lp], "yes") == 0){
				cfg->append.send |= IPMSG_SECRETOPT;
			} else {
				cfg->append.send &= ~IPMSG_SECRETOPT;
			}
		} else if (strcasecmp(key[lp], "editor") == 0) {
			Xstrncpy(cfg->editor, value[lp], PATH_MAX);
		} else if (strcasecmp(key[lp], "send file") == 0) {
			if (*value[lp] == '~' && *(value[lp]+1) == '/'){
				sprintf(cfg->send_file, "%s%s", getenv(ENV_HOME), value[lp]+1);
			} else {
				Xstrncpy(cfg->send_file, value[lp], PATH_MAX);
			}
		}
	    /* 
		   GENERAL
		*/
		else if (strcasecmp(key[lp], "absence") == 0) {
			if (strcasecmp(value[lp], "yes") == 0){
				cfg->absence.mode = TRUE;
			} else {
				cfg->absence.mode = FALSE;
			}
		} else if (strcasecmp(key[lp], "store message") == 0) {
			if ((i = strtol(value[lp], &endp, 0)) != 0) cfg->store_message = i;
		} else if (strcasecmp(key[lp], "use userlist") == 0) {
			if (strcasecmp(value[lp], "yes") == 0){
				cfg->flush_userlist = TRUE;
			} else {
				cfg->flush_userlist = FALSE;
			}
		} else if (strcasecmp(key[lp], "no entry") == 0) {
			if (strcasecmp(value[lp], "yes") == 0){
				cfg->no_entry = TRUE;
			} else {
				cfg->no_entry = FALSE;
			}
		} else if (strcasecmp(key[lp], "hw kana") == 0) {
			if (strcasecmp(value[lp], "kill") == 0){
				cfg->hw_kana = 0;
			} else if (strcasecmp(value[lp], "fit") == 0){
				cfg->hw_kana = 1;
			} else if (strcasecmp(value[lp], "rescue") == 0){
				cfg->hw_kana = 2;
			} else if (strcasecmp(value[lp], "dark") == 0){
				cfg->hw_kana = 3;
			}
		} else if (strcasecmp(key[lp], "character code") == 0) {
			Xstrncpy(cfg->char_code, value[lp], NAMELEN);
		} else if (strcasecmp(key[lp], "flush timeleft") == 0) {
			if ((i = strtol(value[lp], &endp, 0)) != 0) cfg->flush_timeleft = i;
		}
	}
	free(key);
	free(value);

	return TRUE;
}


/*
 * üԤˤ
 */
void information_for_everybody(char* buf, int len, int command, NET_MNG* net,
							   CONFIG_MNG* cfg, USERLIST_MNG* ulm)
{
	int lp;
	long addr;
	USERLIST* ul;

	for (ul = ulm->first; ul; ul = ul->next){
		sender(buf, len, ul->addr, command, net, cfg, ulm);
	}

	for (lp=0; lp<cfg->broadcast.num; lp++){
		addr = hosttoaddr(cfg->broadcast.addr[lp]);
        sender(buf, len, addr, command, net, cfg, ulm);
#if(0)
        sender(buf, len, addr, command, net, cfg, ulm);
        sender(buf, len, addr, command, net, cfg, ulm);
#endif
    }
}

/* Sender */
int sender(unsigned char *buf, int len, long addr, int command,
		   NET_MNG* net, CONFIG_MNG* cfg, USERLIST_MNG* ulm)
{
	return Tsender(NULL, buf, len, addr, command|net->append.ret,
					   net, cfg, ulm);
}

int proxy_sender(unsigned char *buf, int len, char* dest, int command, 
		   NET_MNG* net, CONFIG_MNG* cfg, USERLIST_MNG* ulm)
{
	char prebuf[UDP_BUF];
	int send_len;
	int addr;

	addr = hosttoaddr(cfg->server);
	send_len = sprintf(prebuf, "%d:%d:%s:", 
					   TIPMSG_CMD_VERSION, cfg->special_mode, dest);
	send_len += len;
	d_printf("Psender - addr(%s:%u) : %s...\n", cfg->server, addr, prebuf);
	return Tsender(prebuf, buf, len, addr, command, net, cfg, ulm);
}

/* Sender */
int Tsender(unsigned char* prebuf, unsigned char* buf, int len, long addr, 
			int command, NET_MNG* net, CONFIG_MNG* cfg, USERLIST_MNG* ulm)
{
	int sd = net->sd;
	char full_buf[UDP_BUF];
	static long packet_no = 0;
	struct sockaddr_in	saddr;
	int send_len, header_len;

	if (!prebuf) prebuf = "";

    if (!packet_no){
        packet_no = time(&packet_no) + ((long) getpid() << 16);
    } else {
        packet_no++;
    }

	memset(&saddr, 0, sizeof(saddr));
	saddr.sin_family		= AF_INET;
	saddr.sin_port			= htons(cfg->ipmsg_port);
	saddr.sin_addr.s_addr	= addr;

	/* Make Message */
	if (len > UDP_BUF-100){
		len = UDP_BUF-100;
	}
	
	sprintf(full_buf, "%s%d:%ld:%s:%s:%d:", prebuf,
			IPMSG_VERSION, packet_no, cfg->username, cfg->hostname, command);
	header_len = strlen(full_buf);
    if (buf){
		memcpy(full_buf + header_len, buf, len);
	}

	/* Send */
	if ((send_len = Xsendto(cfg, sd, full_buf, header_len + len, 0, (struct sockaddr *)&saddr, sizeof(saddr))) == -1){
		perror("sendto err");
	}
    
	return send_len;
}

/* ۥ̾ -> ɥ쥹 Ѵ */
long hosttoaddr(char *target)
{
	unsigned long addr;
	struct hostent *host;

    if (strcmp(target, BROADCAST) == 0){
        return ~0;
    }

	if ((addr = inet_addr(target)) == -1){
		if ((host = (struct hostent *)gethostbyname(target)) != NULL){
			addr = *(long *)host->h_addr;
		} else {
            fprintf(stderr, "invalid hostname %s\n", target);
			perror(NULL);
			return 0;
		}
	}
    
	return addr;
}

/* Receive Message function */
int recver(NET_MNG* net, CONFIG_MNG* cfg, USERLIST_MNG* ulm, MSGPACKAGE_MNG* mpm)
{
	int ret, len;
    int retval;
    fd_set rfds;
    struct timeval tv;
	char entry_buf[NAMELEN*2];

	/* ȥ꡼ */
	sprintf(entry_buf, "%s%c%s", cfg->nickname, '\0', cfg->groupname);
	len = strlen(cfg->nickname) + strlen(cfg->groupname) + 2;
	information_for_everybody(entry_buf, len, IPMSG_BR_ENTRY, net, cfg, ulm);
	ulm->flag_flush = FALSE;
	if (cfg->no_entry){
		/* ȥ */
		information_for_everybody(NULL, 0, IPMSG_BR_EXIT, net, cfg, ulm);
		sleep(1);
		information_for_everybody(NULL, 0, IPMSG_BR_EXIT, net, cfg, ulm);
	}


	while(!g_exit){
        FD_ZERO(&rfds);
        FD_SET(net->sd, &rfds);
        tv.tv_sec = cfg->flush_timeleft;
        tv.tv_usec = 0;
        /* ճ */
        retval = select(net->sd + 1 , &rfds, NULL, NULL, &tv);
        if (retval == -1){
            if (errno != EINTR) perror("select fail");
            if (cfg->flush_userlist) flush_userlist(cfg->userlist_file, ulm);
			ret = 0;
            goto ERR0;
        } else if (!retval){
            if (ulm->flag_flush && cfg->flush_userlist){
				/* USER LIST ν񤭤 */
                flush_userlist(cfg->userlist_file, ulm);
            }
            continue;
        }
		if (!do_receive(net, cfg, ulm, mpm)){
			d_printf("do_selected_process fail.\n");
		}
	}
  ERR0:
	return ret;
}

int do_receive(NET_MNG* net, CONFIG_MNG* cfg, USERLIST_MNG* ulm, MSGPACKAGE_MNG* mpm)
{
    USERLIST* ul;
	unsigned char recvbuf[UDP_BUF];
	int len, elen;

	int sd = net->sd;
	int	size = sizeof(struct sockaddr_in);
	char buf[MAXBUFLEN];
	MSG msg;
	char entry_buf[NAMELEN*2];
	MSGPACKAGE* package = NULL;
	struct sockaddr_in addr;

	/* ǡ */
	if ((len = Xrecvfrom(cfg, sd, recvbuf, UDP_BUF-1, 0, (struct sockaddr *)&addr, &size)) == -1){
		perror("recvfrom error");
		goto ERR0;
	}
	recvbuf[len]='\0';

	memset(&msg, 0, sizeof(MSG));
	if (!decom_msg(&msg, recvbuf, len+1)){
		d_printf("Fail in decom message.\n");
		goto EXIT0;
	}
	/* Proxy working */
	if (msg.cmd_ver){
		int addr;
		d_printf("Found cmd_ver[0x%x].\n", msg.cmd_ver);
		if (msg.cmd & SPECIAL_SEND_MODE){
			if (msg.cmd & SPECIAL_OPT_USE_USERNAME){
				addr = iusertoaddr(msg.data, ulm);
			} else {
				addr = ihosttoaddr(msg.data, ulm);
			}
			if (addr){
				d_printf("PROXY To %s : %s\n", msg.data, msg.extend);
				Tsender(NULL, msg.extend, strlen(msg.extend)+1, addr, 
					   msg.command, net, cfg, ulm);
			} else {
				fprintf(stderr, "Unknown destination(%s).\n", msg.data);
			}
		} else {
			d_printf("Not found valid tipmsg cmd.\n");
		}
		goto EXIT0;
	}

	/* ޥα */
	d_printf("Command 0x%x\n", msg.command);
	switch(GET_MODE(msg.command)){
	case IPMSG_BR_ENTRY:
		if (cfg->print_entry){
			if ((ul = construct_userlist_from_msg(&msg, &addr))){
				fprintf(stdout, "Entry: %s@%s%s%s[%s]\n", 
						ul->nickname ? ul->nickname : ul->user,
						ul->groupname, ul->groupname[0] ? "/" : "", ul->host, 
						inet_ntoa(addr.sin_addr));
			} else {
				fprintf(stdout, "Exit :%s@%s[%s]\n", msg.msg_user, 
						msg.msg_host, inet_ntoa(addr.sin_addr));
			}
		}
		elen = sprintf(entry_buf, "%s%c%s", cfg->nickname, '\0', cfg->groupname);
		if (!cfg->no_entry && Tsender(NULL, entry_buf, elen, 
									  addr.sin_addr.s_addr, 
									  IPMSG_ANSENTRY, net, cfg, ulm) == -1){
			d_printf("ANSENTRY ERR\n");
			goto ERR0;
		}
		/* ̤ȴ */
	case IPMSG_ANSENTRY:
		if (!(ul = construct_userlist_from_msg(&msg, &addr))){
			goto ERR0;
		}
		append_userlist(ulm, ul);
		ulm->flag_flush = TRUE;
		break;
	case IPMSG_BR_ABSENCE:
		d_printf("Get IPMSG_BR_ABSENCE\n");
		if (!(ul = construct_userlist_from_msg(&msg, &addr))){
			goto ERR0;
		}
		append_userlist(ulm, ul);
		ulm->flag_flush = TRUE;
		break;
	case IPMSG_BR_EXIT:
		if (cfg->print_entry){
			if ((ul = construct_userlist_from_msg(&msg, &addr))){
				fprintf(stdout, "Exit : %s@%s%s%s[%s]\n", 
						ul->nickname ? ul->nickname : ul->user,
						ul->groupname, ul->groupname[0] ? "/" : "", ul->host, 
						inet_ntoa(addr.sin_addr));
			} else {
				fprintf(stdout, "Exit :%s@%s[%s]\n", msg.msg_user, 
						msg.msg_host, inet_ntoa(addr.sin_addr));
			}
		}
		delete_userlist_by_addr(ulm, addr.sin_addr.s_addr);
		ulm->flag_flush = TRUE;
		break;
	case IPMSG_RECVMSG:
		if (cfg->live) fprintf(stdout, RECVMSG_PRT, msg.msg_user, msg.msg_host);
		break;
	case IPMSG_READMSG:
		if (msg.command & IPMSG_READCHECKOPT){
			d_printf("Has READCHECKOPT\n");
			sprintf(buf, "%d", msg.packet_no);
			sender(buf, strlen(buf)+1, addr.sin_addr.s_addr, IPMSG_ANSREADMSG,
				   net, cfg, ulm);
		}
		if (cfg->live) fprintf(stdout, READMSG_PRT, msg.msg_user, msg.msg_host);
		break;
	case IPMSG_GETINFO:
		sender(cfg->vermsg, strlen(cfg->vermsg)+1, 
			   addr.sin_addr.s_addr, IPMSG_AUTORETOPT|IPMSG_SENDINFO,
			   net, cfg, ulm);
		break;
	case IPMSG_GETABSENCEINFO:
		if (net->append.ret & IPMSG_ABSENCEOPT){
			send_file(addr.sin_addr.s_addr, cfg->absence.file, 
					  IPMSG_AUTORETOPT|IPMSG_SENDABSENCEINFO, net, cfg, ulm);
		} else {
			sender(ABSENCE_MESSAGE, strlen(ABSENCE_MESSAGE)+1, 
				   addr.sin_addr.s_addr, 
				   IPMSG_AUTORETOPT|IPMSG_SENDABSENCEINFO, net, cfg, ulm);
		}
		break;
	case IPMSG_SENDMSG:
		switch (check_message(&msg, &addr, net, cfg, ulm)){
		case MSG_NORMAL:
			d_printf("RECV NORMAL\n");
			store_message(&msg, &addr, cfg, ulm);
			if (!(ul = search_userlist_by_addr(ulm, addr.sin_addr.s_addr))){
				sender(NULL, 0, addr.sin_addr.s_addr, IPMSG_BR_ENTRY, 
					   net, cfg, ulm);
			} else {
				if(!(package = construct_msgpackage(ul, &msg))){
					d_printf("Can't create messge package buffer.\n");
					goto EXIT0;
				}
				if (!append_msgpackage(mpm, package)){
					d_printf("Append Msg Package False.\n");
				}
			}
			break;
		case MSG_QUIT:
			g_exit = 1;
			goto ERR0;
		case MSG_UPDATE:
			d_printf("Check message UPDATE return.\n");
			ulm->flag_flush = TRUE;
			break;
		default:
			break;
		}
		break;
	default:
		d_printf("Recive unknow command: 0x%08x\n", msg.command);
	}

  EXIT0:
	fflush(stdout);
	return len;

  ERR0:
	fflush(stdout);
	return 0;
}

/* ե */
int send_file(long addr, char* fname, int command, 
			  NET_MNG* net, CONFIG_MNG* cfg, USERLIST_MNG* ulm)
{
	struct stat sbuf;
	int len;
	char buf[UDP_BUF];
	int fd;

	d_printf("START send_file(%s)\n", fname);
	if (fname[0] == '\0') return 0;
	if (stat(fname, &sbuf) != 0){
		fprintf(stderr, "Can't get file status(%s) : %s\n", 
				fname, ERRMSG);
		return 0;
	}
	if (!sbuf.st_size){
		fprintf(stderr, "File(%s) size is Zero.\n", fname);
		return 0;
	}
	if ((fd = open(fname, O_RDONLY)) <0){
		fprintf(stderr, "Can't open file(%s) : %s\n", fname, ERRMSG);
		return 0;
	}
	len = (sbuf.st_size < UDP_BUF-1) ? sbuf.st_size : UDP_BUF -1;
	if (read(fd, buf, len)<0){
		fprintf(stderr, "Can't open file(%s) : %s\n", fname, ERRMSG);
		return 0;
	}
	buf[len]='\0';
	return sender(buf, strlen(buf)+1, addr, command, net, cfg, ulm);
}

int set_signal(void (*handler)(int))
{
	struct sigaction act;
	int ret;

	act.sa_handler = handler;
	sigemptyset(&act.sa_mask);
	act.sa_flags = SA_NOCLDSTOP;

	ret = sigaction(SIGALRM, &act, 0);
	ret |= sigaction(SIGHUP, &act, 0);
	ret |= sigaction(SIGINT, &act, 0);
	ret |= sigaction(SIGPIPE, &act, 0);
	ret |= sigaction(SIGTERM, &act, 0);
	ret |= sigaction(SIGQUIT, &act, 0);
	ret |= sigaction(SIGCHLD, &act, 0);
	if (ret) perror("setaction failer in  basic sigaction");
	
	ret = sigaction(SIGFPE, &act, 0);
	ret |= sigaction(SIGILL, &act, 0);
	ret |= sigaction(SIGSEGV, &act, 0);
	if (ret) perror("setaction failer in  advanced sigaction");

	return ret;
}

void interrupt_exit(int num)
{
	switch(num){
	case SIGPIPE:
		break;
	default:
		g_exit = 1;
	}
}

/* Ȥɽ */
void print_usage()
{
    printf("tipmsg ver %s - Text IP Messenger\n", TIPMSG_VERSION);
}

/* åνå */
int check_message(MSG* msg, struct sockaddr_in* psaddr, 
				  NET_MNG* net, CONFIG_MNG* cfg, USERLIST_MNG* ulm)
{
	char entry_buf[NAMELEN*2];
	int len;
	char buf[UDP_BUF];

    /* å */
    if ((msg->command & IPMSG_SENDCHECKOPT) &&
		!(msg->command & (IPMSG_BROADCASTOPT|IPMSG_AUTORETOPT))){
        sprintf(buf, "%d", msg->packet_no);
        if (!sender(buf, strlen(buf)+1, psaddr->sin_addr.s_addr, IPMSG_RECVMSG,
					net, cfg, ulm)){
            return 0;
        }
    }
    if (msg->command & IPMSG_SECRETOPT){
        sprintf(buf, "%d", msg->packet_no);
		if (!sender(buf, strlen(buf)+1, psaddr->sin_addr.s_addr, 
					IPMSG_READMSG|IPMSG_AUTORETOPT,
					net, cfg, ulm)){
		}
    }
	/* Ƭʸˤưѹ */
	if (strncmp(msg->extend, "quit", 4) == 0){
		d_printf("QUIT REQUIRED!\n");
		msg->extend[0]='\0';
		return MSG_QUIT;
	} else if (strncmp(msg->extend, "absence", 7) == 0){
		d_printf("%sABSENCE REQUIRED!\n", 
				 (net->append.ret & IPMSG_ABSENCEOPT) ? "UN" : "");
		msg->extend[0]='\0';
		/* Ժưȿž*/
		if (net->append.ret & IPMSG_ABSENCEOPT){
			net->append.ret &= ~IPMSG_ABSENCEOPT;
		} else {
			net->append.ret |= IPMSG_ABSENCEOPT;
		}
		sprintf(entry_buf, "%s%c%s", cfg->nickname, '\0', cfg->groupname);
		len = strlen(cfg->nickname) + strlen(cfg->groupname) + 2;
		information_for_everybody(entry_buf, len, IPMSG_BR_ABSENCE, 
								  net, cfg, ulm);
		return MSG_ABSENCE;
	} else if (strncmp(msg->extend, "update", 6) == 0){
		d_printf("UPDATE REQUIRED!\n");
		msg->extend[0]='\0';
		destroy_userlist(ulm);
		load_config(cfg->filename, cfg);
		
		sprintf(entry_buf, "%s%c%s", cfg->nickname, '\0', cfg->groupname);
		len = strlen(cfg->nickname) + strlen(cfg->groupname) + 2;
		information_for_everybody(entry_buf, len, IPMSG_BR_ENTRY, 
								  net, cfg, ulm);
		return MSG_UPDATE;
	}

	/* ưåˤϤʹߤαϤʤ */
	if (msg->command & IPMSG_AUTORETOPT){
		d_printf("It's IPMSG_AUTORETOPT.\n");
		return MSG_NORMAL;
	}
	/* Ժ߻ */
	if (net->append.ret & IPMSG_ABSENCEOPT){
		d_printf("cfg->absence.file[%s]\n", cfg->absence.file);
		send_file(psaddr->sin_addr.s_addr, cfg->absence.file, 
				  IPMSG_AUTORETOPT|IPMSG_SENDMSG, net, cfg, ulm);
	}
	return MSG_NORMAL;
}

int send_message(NET_MNG* net, CONFIG_MNG* cfg, USERLIST_MNG* ulm, char* send_list[])
{
	int lp, len, pos = 0;
	unsigned char buf[UDP_BUF], ans[3];

	if (cfg->editor[0]){
		if (!(pos = create_sendbuf_with_editor(buf, UDP_BUF, cfg))){
			return 0;
		}
	} else {
		while ((len = read(STDIN_FILENO, buf + pos, UDP_BUF - pos))) {
			if ((pos += len) >= UDP_BUF) break;
		}
	}

	/* ɸϤߥʥʤ顢ǧԤʤ */
	if (isatty(STDIN_FILENO)){
		fprintf(stderr, "Send message OK?[y/n]\n");
		while(fgets(ans, 3, stdin) != NULL && !ans[0]);
		if (toupper(ans[0]) != 'Y'){
			fprintf(stdout, "Cancel!\n");
			return 0;
		}
	}

	for (lp=0; send_list[lp]; lp++){
		d_printf("SEND MESSAGE[%s] : %s\n", send_list[lp], buf);
		proxy_sender(buf, pos, send_list[lp], 
					 IPMSG_SENDMSG|cfg->append.send,
					 net, cfg, ulm);
	}
	return lp;
}

/* ｪλϿ */
int create_sendbuf_with_editor(char* buf, int size, CONFIG_MNG* cfg)
{
	pid_t pid;
	int status, fd = -1, len, pos = 0;
	char* send_file = cfg->send_file;
	char* editor = cfg->editor;

	if (!isatty(STDIN_FILENO)){
		/* ɸϤߥʥǤʤϡɸϤΥǡ
           ե˽񤭽Ф */
		while ((len = read(STDIN_FILENO, buf + pos, size - pos))) {
			if (len < 0) fprintf(stderr, "Can't read file(%s) : %s\n", send_file, ERRMSG);
			if ((pos += len) >= size) break;
		}
		if ((fd = open(send_file, O_RDWR|O_CREAT|O_APPEND, 0600)) == -1){
			fprintf(stderr, "Can't open file(%s) : %s\n", send_file, ERRMSG);
			return 0;
		}
		if (write(fd, buf, pos)<0){
			fprintf(stderr, "Can't write file(%s) : %s\n", send_file, ERRMSG);
		}
		close(fd);
		pos = 0;
	}

	if ((pid = fork()) == 0) {
		char command[PATH_MAX];
		sprintf(command, "%s %s", editor, send_file);
		execlp("/bin/sh", "sh", "-c", command, NULL);
		/* execlp Фʹߤϼ¹Ԥʤ */
		perror("Can't exec editor");
		return 0;
	} else if (pid == -1) {
		perror("Can't create process");
		return 0;
	}
	if (wait(&status)<=0){
		perror("Error on wait for editor");
		return 0;
	}
		
	if ((fd = open(send_file, O_RDONLY)) == -1){
		fprintf(stderr, "Can't open file(%s) : %s\n", send_file, ERRMSG);
		return 0;
	}
	while ((len = read(fd, buf + pos, size - pos))) {
		if (len < 0) fprintf(stderr, "Can't read file(%s) : %s\n", send_file, ERRMSG);
		if ((pos += len) >= size) break;
	}

	if (!cfg->send_file_keep_it) unlink(send_file);
	d_printf("Messege length is %d.\n", pos);
	close(fd);
	return pos;
}
